; **
; Intellivision for GameBoy Color v1.1
; Copyright(C) 2000,03 By Carl Mueller, Jr.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

REVERSI_5FFC::

        di                              ; don't allow VBlankFunc to interrupt

        ld              sp, $5BBA       ; return to REVERSI @ $5DDD

        ld              a, [R2]
        and             $3F
        jp              z, ifB_BREAK_2

        reti                            ; return, enabling interrupts

;BUMPJUMP_6094::
;
;        ld              de, $61A2          ; return to BUMPJUMP @ $60D1
;        ld              hl, ScrollDown_BJ  ;
;
;        jr              ScrlDispatch

MISSIONX_6386::

        ld              de, $6792       ; $63C9
        ld              hl, ScrollDown

        jr              ScrlDispatch

;ADD_6195::
;
;        ld              de, $634A       ; return to AD&D @ $61A5
;        ld              hl, ScrollRight
;
;        jr              ScrlDispatch

;ADD_61AF::
;
;        ld              de, $63E8       ; return to AD&D @
;        ld              hl, ScrollDown
;
;        jr              ScrlDispatch

;ADD_61F8::
;
;        ld              de, $6404       ; return to AD&D @ $6202
;        ld              hl, ScrollUp
;
;        jr              ScrlDispatch

;ADD_6181::
;
;        ld              de, $634C       ; return to AD&D @ $61A6
;        ld              hl, ScrollLeft
;
;        jr              ScrlDispatch

;AUTORACE_5F50::
;
;        ld              de, $5ECA       ; return to AUTORACE @ $5F65
;        ld              hl, ScrollRight
;
;        jr              ScrlDispatch

;AUTORACE_5F70::
;
;        ld              de, $5F6A       ; return to AUTORACE @ $5FB5
;        ld              hl, ScrollDown
;
;        jr              ScrlDispatch

;AUTORACE_5FB9::
;
;        ld              de, $5F86       ; return to AUTORACE @ $5FC3
;        ld              hl, ScrollUp
;
;        jr              ScrlDispatch

;AUTORACE_5F41::
;
;        ld              de, $5ECE       ; return to AUTORACE @ $5F67
;        ld              hl, ScrollLeft
;
;        jr              ScrlDispatch

;TROPTROB_5524::
;
;        ld              de, $4A6A       ; return to TROPTROB @ $5535
;        ld              hl, ScrollLeft
;
;        jr              ScrlDispatch

;BODYSLAM_57BA::
;
;        ld              de, $5028       ; return to BODYSLAM @ $5814
;        ld              hl, ScrollLeft
;
;        jr              ScrlDispatch

;BODYSLAM_57E4::
;
;        ld              de, $5024       ; return to BODYSLAM @ $5812
;        ld              hl, ScrollRight
;
;        jr              ScrlDispatch

;SKIING_5F6A::
;
;        ld              de, $5EE8       ; return to SKIING @ $5F74
;        ld              hl, ScrollUp
;
;        jr              ScrlDispatch

ICETREK_5526::

        ld              de, $4A6E       ; return to ICETREK @ $5537
        ld              hl, ScrollLeft

        jr              ScrlDispatch

;DREADNAN_5E88::
;
;        ld              de, $5EB2       ; return to DREADNAN @ $5F59
;        ld              hl, ScrollUpLeft
;
;        jr              ScrlDispatch

;DREADNAN_5E97::
;
;        ld              de, $5EB2       ; return to DREADNAN @ $5F59
;        ld              hl, ScrollUp
;
;        jr              ScrlDispatch

;DREADNAN_5F39::
;
;        ld              de, $5EB2       ; return to DREADNAN @ $5F59
;        ld              hl, ScrollLeft
;
;        jr              ScrlDispatch

;DREADNAN_5ED6::
;
;        ld              de, $5EB2       ; return to DREADNAN @ $5F59
;        ld              hl, ScrollDownLeft
;
;        jr              ScrlDispatch

;DREADNAN_5F0F::
;
;        ld              de, $5EB2       ; return to DREADNAN @ $5F59
;        ld              hl, ScrollDown
;
;        jr              ScrlDispatch

;FROGGER_5F0D::
;
;        ld              de, $5FFA       ; return to FROGGER @ $5FFD
;        ld              hl, ScrollRow
;
;        jr              ScrlDispatch

;HORSE_557A::
;SPFOOT_AE65::

;        ld              hl, SYSTEM_RAM + 1  ; hl -> BackTab[ 0, 0 ].H
;        ld              de, 20 * 2          ; de  = NewLine
;        ld              bc, $20 << 8 + 12   ; prepare mask, do 12 rows
;.Loop
;        ld              a, [hl]         ; a <- ??aFtNNn
;        and             b               ; is a (advance) == 1 ?
;        jr              z, .NoA         ; no,  so nothing to copy over
;
;        xor             [hl]            ; a  = ??aFtNNn (a=0)
;        ld              [hl+], a        ; update BackTab[ 0, y ].H
;        inc             l
;
;        ld              a, [hl]         ; a <- ??aFtNNn
;        or              b               ;    = ??aFtNNn (a=1)
;        ld              [hl-], a        ; update BackTab[ 1, y ].H
;
;        dec             l               ; hl -> BackTab[ 0, y ].H
;.NoA
;        add             hl, de          ; pos @ next row
;
;        dec             c               ; did all 12 rows ?
;        jr              nz, .Loop       ; no,  so keep looping
;
;        ld              c, cROMB0 & $FF ; bc -> rROMB0
;                                        ;  c -> cROMB0
;
;;        ld              de, $4B20       ; return to HORSE @ $5590
;        ld              de, $7D2C       ; return to SPFOOT @ $AE96
;        ld              hl, ScrollLeft
;
;        jr              ScrlDispatch

SPFOOT_AE7D::

        ld              hl, SYSTEM_RAM + 20 * 2 + 1 ; hl -> BackTab[ 0, 1 ].H
        ld              de, 20 * 2          ; de  = NewLine
        ld              bc, $20 << 8 + 11   ; prepare mask, do 12 rows
.Loop
        ld              a, [hl]         ; a <- ??aFtNNn
        and             b               ; is a (advance) == 1 ?
        jr              z, .NoA         ; no,  so nothing to copy over

        xor             [hl]            ; a  = ??aFtNNn (a=0)
        ld              [hl-], a        ; update BackTab[ 0, y ].H
        dec             l

        ld              a, [hl]         ; a <- ??aFtNNn
        or              b               ;    = ??aFtNNn (a=1)
        ld              [hl+], a        ; update BackTab[ 19, y - 1 ].H

        inc             l               ; hl -> BackTab[ 0, y ].H
.NoA
        add             hl, de          ; pos @ next row

        dec             c               ; did all 12 rows ?
        jr              nz, .Loop       ; no,  so keep looping

        ld              c, cROMB0 & $FF ; bc -> rROMB0
                                        ;  c -> cROMB0

        ld              de, $7D2A       ; return to SPFOOT @ $AE95
        ld              hl, ScrollRight

        jr              ScrlDispatch

HVRFORCE_5317::

        ld              de, $4688       ; return to HVRFORCE @ $5344
        ld              hl, ScrollLeft

        jr              ScrlDispatch

HVRFORCE_534A::

        ld              de, $46E8       ; return to HVRFORCE @ $5374
        ld              hl, ScrollRight

        jr              ScrlDispatch

HVRFORCE_5381::

        ld              de, $47C2       ; return to HVRFORCE @ $53E1
        ld              hl, ScrollDown

        jr              ScrlDispatch

HVRFORCE_53E4::

        ld              de, $4800       ; return to HVRFORCE @ $5400
        ld              hl, ScrollUp

        jr              ScrlDispatch

DECATHLN_620D::

        ld              de, $644C       ; return to DECATHLN @ $6226
        ld              hl, ScrollLeft

        jr              ScrlDispatch

TUTKHAM_670F::

        ld              de, $6E30       ; return to TUTKHAM @ $671A
        ld              hl, ScrollLeft

        jr              ScrlDispatch

TUTKHAM_66AD::

        ld              de, $6D78       ; return to TUTKHAM @ $66BC
        ld              hl, ScrollRight

        jr              ScrlDispatch

DRACULA_5524::

        ld              de, $4A6A       ; return to DRACULA @ $5535
        ld              hl, ScrollLeft

        jr              ScrlDispatch

DRACULA_54D6::

        ld              de, $49D6       ; return to DRACULA @ $54EB
        ld              hl, ScrollRight

ScrlDispatch::

        ld              sp, SP_1        ; use STACK_1 for ScrlDispatch

        ei                              ; interrupts can't be off for so long

        ld              a, [c]          ; a <- [cROMB0] (current ROM bank #)

        push            af              ; save [cROMB0]
        push            de              ; save CP1610 return address

        ld              a, BANK(BKG)    ; a = #/bank where BktWrite_XX is
        ld              [c], a          ; note new ROM bank # for ISRs
        ld              [bc], a         ; switch to new ROM bank

        jp              [hl]            ; jump to scrolling routine

ScrlDispatch_Return::

        pop             hl              ; rest. CP1610 return address
        pop             af              ; rest. [cROMB0]

        ld              bc, $2000 + cROMB0 & $FF  ; bc -> rROMB0
                                                  ;  c -> cROMB0

        ld              [c], a          ; note previous ROM bank # for ISRs
        ld              [bc], a         ; switch to previous ROM bank

        di

        ld              sp, hl          ; sp = CP1610 return address

        reti
